#ifndef _GTL_CIRCLE
#define _GTL_CIRCLE

#include "vertex_array.H"

namespace gtl
{

template <class T=long double>
class circle : public vertex_array<T>
  {
  public:
    circle() {}
    circle(const circle& c)
      {
        this->vertices.resize(2);
        this->vertices[0]=c.vertices[0];
        this->vertices[1]=c.vertices[1];
      }
    circle(const vertex<T>& a, const vertex<T>& b)
      {
        this->vertices.resize(2);
        this->vertices[0]=a;
        this->vertices[1]=b;
      }
    circle(const T ax, const T ay, const T bx, const T by)
      {
        this->vertices.resize(2);
        this->vertices[0]=vertex<T>(ax,ay);
        this->vertices[1]=vertex<T>(bx,by);
      }

    friend std::ostream& operator<<(std::ostream& os, const circle& c)
      { 
        return os << "[" << c.vertices[0] << ":" 
                  << (c.vertices[0]-c.vertices[1]).abs() << "]";
      }

  };

} // namespace gtl

#endif // _GTL_CIRCLE
