#ifndef _GROBJ
#define _GROBJ

#include <qcanvas.h>

#include "vertex_array.H"
using namespace gtl;

class QCanvasItemList;
class QString;

enum grobjtype { linetype, circletype };

class GrobjException {};

class Grobj
{
public:
	Grobj ( grobjtype t, QCanvas *c );
	~Grobj ();
	QString text();
	void add(vertex<int>& v);
	void create_va();
	void add( double x, double y );
	void finish();
	void set_last(vertex<int>& v);
	void del_last();
	bool is_complete();
	
	vertex<int> get_centre();
	
	bool collide( vertex<int> v );
	void move( vertex<int> v );
	void rotate( vertex<int> from, vertex<int> to );
	void scale( double s );
	void stretch( vertex<int> from, vertex<int> to );
	void fix_va();
	
	
private:
	void recreate();
	void restore_va();

	vertex_array<> *va, *bak_va;
	QCanvasItemList cil;
	QCanvasItem *last_item;
	grobjtype type;
	std::vector<vertex<> > activepts;
	vertex<> lastpt, centre;
	bool complete;
	QCanvas *canvas;
};

#endif // _GROBJ
